import logging
import os
import sys

from pysmt.shortcuts import Symbol, And, Not, Or

from mc308.logics.bool import BoolFormula
from mc308.auto.ts import TS, FinitePath
from mc308.auto.nfa import NFA
from mc308.parsers.ts_parser import TSParser
from mc308.auto.visualization import ts_to_dot, to_png

from mc308.td2 import nfa_intersection, ts_nfa_product, check_safety

def main():
    """
    This script is not an exhaustive test for your implementation.

    You will have to write the test cases and check your implementation is
    behaving as expected.

    What we provide here:
    - An example creating a NFA (NOTE: there is no implemented concrete syntax
      and parser for NFAs, so you will have to write the test cases in Python).
    - Import the functions you have to implement from td2.py
    """
    
    #
    # create the set of atomic propositions
    # Remember, \Sigma = 2^AP so
    # AP = {p_1} means \Sigma = { {}, {p_1}}
    # AP = {p_1, p_2} means \Sigma = { {}, {p_1}, {p_2}, {p_1,p_2}}
    #
    ap = [Symbol("a_%d" % int(s)) for s in range(1)]
    a1 = [ap[0]]
    b1 = frozenset()
    # In the following, we use a1,b1 as letter symbols for the sets {p_1} and {}

    A1 = NFA([1], [], [1], [], ap)                # recognize the empty language
    A2 = NFA([1], [(1,a1,1)], [1], [1], ap)     # recognize {a1}*
    # ({a1}* b1) + ({b1}* a1)
    A3 = NFA([1,2,3], [(1,a1,2), (2,b1,2), (1,b1,3), (3,a1,3) ], [1], [2,3], ap)
    A4 = NFA([1,2,3,4],
             [(1,a1,2), (2,a1,1),
              (1,b1,3),
              (3,b1,4),(4,b1,3)],
             [1],
             [3],
             ap)

    # To test the intersection, you can try (writing & as intersection):
    # A1 & A2
    # A2 & A3
    # A3 & A4

    print(A1,A2,A3,A4)


if __name__ == "__main__":
    main()
